﻿using System;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Windows.DataPresenter;

namespace ForumPostApp
{
    /// <summary>
    /// Interaction logic for Grid1.xaml
    /// </summary>
    public partial class Grid1 : UserControl
    {
        public Grid1()
        {
            InitializeComponent();

            grid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(grid1_FieldLayoutInitialized);
        }

        void grid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            foreach (var field in e.FieldLayout.Fields)                     
            {
                field.Height = new FieldLength(20);

                var settings = new FieldSettings();
                settings.LabelClickAction = LabelClickAction.Nothing;
                settings.AllowGroupBy = false;
                settings.EditorType = typeof(ControlHostEditor);

                // set editor/renderer
                var dataTemplateName = field.DataType.Name;
                string editDataTemplateName = "Edit" + dataTemplateName;
                string renderDataTemplateName = "Render" + dataTemplateName;
                settings.EditAsType = field.DataType;
                settings.EditorStyle = new Style(typeof(ControlHostEditor), (Style)FindResource("baseHostEditorStyle"));
                settings.EditorStyle.Setters.Add(new Setter(ControlHostEditor.ValueTypeProperty, field.DataType));
                settings.EditorStyle.Setters.Add(new Setter(ControlHostEditor.EditDataTemplateProperty,
                    FindResource(editDataTemplateName)));
                settings.EditorStyle.Setters.Add(new Setter(ControlHostEditor.RenderDataTemplateProperty,
                    FindResource(renderDataTemplateName)));

                //set CellValuePresenterStyle
                settings.CellValuePresenterStyle = new System.Windows.Style(typeof(CellValuePresenter));
                settings.CellValuePresenterStyle.Setters.Add(new Setter(CellValuePresenter.ContentTemplateProperty, this.Resources["EditEntryValue"] as DataTemplate));

                field.Settings = settings;
            }
        }
    }
}
